% Lezione di lab TTR  -14/03/2016- Legge di Bayes - Marco Cristani
close all;
clear all;
clc

% ---------------------------------------
% Esercizio 1 - Riconoscimento di facce (ex ES. 3 della scorsa lezione)
% ---------------------------------------
fprintf(' ---------------\n')
fprintf(' Esercizio 3\n')
fprintf(' ---------------\n')
A=rgb2gray(imread('1.jpg'));
A=A(1:4:end,1:4:end);
rows = size(A,1);
cols = size(A,2); 

figure; 
set(gcf,'name','Medie e varianze, metodo veloce')
colormap gray; subplot 221 ; imagesc(A); 
title('Mean class 1');
Mu1 = A(:);
Sigma1 = ones(rows*cols,1).*10;
subplot 222 ; imagesc(reshape(Sigma1,rows,cols)); colorbar; 
title('Sigma class 1');

B=rgb2gray(imread('12.jpg'));
B=B(1:4:end,1:4:end);
subplot 223; imagesc(B); 
title('Mean class 2');
Mu2 = B(:);
Sigma2 = ones(rows*cols,1).*10;
subplot 224 ; imagesc(reshape(Sigma2,rows,cols)); colorbar; 
title('Sigma class 2');

C1=[];
C2=[];
for i=1:12
    test = rgb2gray(imread(strcat(num2str(i),'.jpg')));
    test = test(1:4:end,1:4:end);
    test=test(:);
    LK1 = sum(log(normpdf(double(test),double(Mu1),double(Sigma1))));
    LK2 = sum(log(normpdf(double(test),double(Mu2),double(Sigma2))));
    if LK1 >LK2
        C1 = [C1,i];
    else
        C2 = [C2,i];
    end
end
latoC1=ceil(sqrt(length(C1)));
latoC2=ceil(sqrt(length(C2)));
figure;
set(gcf,'name','Classe 1')
count=1;
for i=1:length(C1)
    
    subplot(latoC1,latoC1,i);
    test = rgb2gray(imread(strcat(num2str(C1(i)),'.jpg')));
    imagesc(test);axis off; colormap gray;
    
end

figure;
set(gcf,'name','Classe 2')
count=1;
for i=1:length(C2)
    
    subplot(latoC2,latoC2,i);
    test = rgb2gray(imread(strcat(num2str(C2(i)),'.jpg')));
    imagesc(test);axis off; colormap gray;
    
end    
fprintf('FINE! Premi un tasto per continuare!\n')
pause

% -------------------------------------------------
% Esercizio 2 - Riconoscimento di facce "robusto"
% -------------------------------------------------
fprintf(' ---------------\n')
fprintf(' Esercizio 4\n')
fprintf(' ---------------\n')

Vol1 = [];
Vol2 = [];

train1 = [1:5];
train2 = [8:10];
traintot = [train1,train2];

for i=train1
    train = rgb2gray(imread(strcat(num2str(i),'.jpg')));
    train = train(1:4:end,1:4:end);
    Vol1 = [Vol1,train(:)];
end
for i=train2
    train = rgb2gray(imread(strcat(num2str(i),'.jpg')));
    train = train(1:4:end,1:4:end);
    Vol2 = [Vol2,train(:)];
end


Eff_mean1 = mean(Vol1,2);
Eff_sigma1 = std(single(Vol1)');
Eff_mean2 = mean(Vol2,2);
Eff_sigma2 = std(single(Vol2)');

h_Mean_Std = figure;
set(gcf,'name','Medie e varianze, metodo robusto')
colormap gray;
subplot 221; imagesc(reshape(Eff_mean1,rows,cols)); title('Mean class 1'); 
subplot 222; imagesc(reshape(Eff_mean2,rows,cols)); title('Mean class 2'); 
subplot 223; imagesc(reshape(Eff_sigma1,rows,cols)); title('Std class 1'); colorbar
subplot 224; imagesc(reshape(Eff_sigma2,rows,cols)); title('Std class 2'); colorbar

 
C1=[];
C2=[];
testtot = setdiff([1:12],traintot);
for i=testtot
    test = rgb2gray(imread(strcat(num2str(i),'.jpg')));
    test = test(1:4:end,1:4:end);
    test = test(:);
    LK1 = sum(log(normpdf(double(test),double(Eff_mean1),double(Eff_sigma1'+eps))));
    LK2 = sum(log(normpdf(double(test),double(Eff_mean2),double(Eff_sigma2'+eps))));
    if LK1 >LK2
        C1 = [C1,i];
    else
        C2 = [C2,i];
    end
    i
end
latoC1=ceil(sqrt(length(C1)));
latoC2=ceil(sqrt(length(C2)));
figure;
set(gcf,'name','Classificazione C1, nuova stima della media')
for i=1:length(C1)
    
    subplot(latoC1,latoC1,i);
    test = rgb2gray(imread(strcat(num2str(C1(i)),'.jpg')));
    imagesc(test);axis off; colormap gray;
    
end


figure;
set(gcf,'name','Classificazione C2, nuova stima della media')
for i=1:length(C2)
    subplot(latoC2,latoC2,i);
    test = rgb2gray(imread(strcat(num2str(C2(i)),'.jpg')));
    imagesc(test);axis off; colormap gray;
end    

%ESERCIZIO: calcola matrice di confusione, precision e recall dei risultati di classificazione

conf = zeros(2,2);
label = [1,1,1,1,1,1,1,2,2,2,2,2];
for i=testtot
    test = rgb2gray(imread(strcat(num2str(i),'.jpg')));
    test = test(1:4:end,1:4:end);
    test = test(:);
    LK1 = sum(log(normpdf(double(test),double(Eff_mean1),double(Eff_sigma1'+eps))));
    LK2 = sum(log(normpdf(double(test),double(Eff_mean2),double(Eff_sigma2'+eps))));
    if LK1 >LK2
        C1 = [C1,i];
        resp = 1;
    else
        C2 = [C2,i];
        resp = 2;
    end
    conf(resp,label(i))=conf(resp,label(i))+1;
end

%calcolo precision e recall
numclassi = 2;
for i=1:numclassi
    prec(i)= conf(i,i)/sum(conf(i,:));
    reca(i)= conf(i,i)/sum(conf(:,i));
end


fprintf('FINE! Premi un tasto per continuare!\n')
pause

% -------------------------------
% Esercizio 3 - BG subtraction
% -------------------------------
fprintf(' ---------------\n')
fprintf(' Esercizio 5\n')
fprintf(' ---------------\n')
C_info = aviinfo('piramide.avi');
C = rgb2gray(frame2im(aviread('piramide.avi',C_info.NumFrames)));
figure; subplot(211); imagesc(C); colormap gray; axis off; set(gcf,'name','Sottrazione del background: stima grezza della scena');
subplot(212); imagesc(C); colormap gray; axis off;
Mu_BG = double(C(:));
sigma_BG = 16;
figure; set(gcf,'name','Sottrazione del background');
for t=1:C_info.NumFrames
    test = rgb2gray(frame2im(aviread('piramide.avi',t)));
    res  = test(:)<Mu_BG-3*sigma_BG | test(:)>Mu_BG+3*sigma_BG;
    subplot(211);
    imagesc(reshape(res,C_info.Height,C_info.Width)); axis image;
    colormap gray;
    subplot(212);
    imagesc(reshape(uint8(res),C_info.Height,C_info.Width).*...
        test); axis image
    pause
end

% ESERCIZIO: Provate a cambiare il fattore di moltiplicazione sulla deviazione standard.
% ESERCIZIO: visualizzate i segnali temporali associati ad ogni pixel; 

for t=1:C_info.NumFrames
 testc(:,:,t) = rgb2gray(frame2im(aviread('piramide.avi',t)));
end
figure;
subplot(211)
plot(squeeze(testc(120,148,:)));
subplot(212)
plot(squeeze(testc(1,1,:)));

fprintf('FINE! Premi un tasto per continuare!\n')
pause

% ---------------------------------------------------------------------------------
% Esercizio 4 - Manipolazione e analisi di gaussiane, unimodali e multivariate
% ---------------------------------------------------------------------------------


clear all;
A= normrnd(0,2,10000,2);

h1 = figure;
scatter(A(:,1),A(:,2));
axis equal

A2d = mvnrnd([0,0],[4,0;0,4],10000);
h2 = figure;
scatter(A2d(:,1),A2d(:,2));
axis equal

% Inserisco una leggera covarianza tra le variabili
A2dc = mvnrnd([0,0],[1,-sqrt(2)/2;-sqrt(2)/2,1],10000);
h2 = figure;
scatter(A2dc(:,1),A2dc(:,2));
axis equal

cova = cov(A2dc);
[v,a]=eig(cova); % che cosa risulta, senza guardare il risultato?

% ESERCIZIO: Provate con distribuzioni 3D, visualizzate

fprintf('FINE! Premi un tasto per continuare!\n')
pause
% -----------------------------------------------
% Esercizio 4 - Funzioni discriminanti lineari
% -----------------------------------------------


num_s=100;

Pw1=0.5;
Pw2=0.5;

Mu1 = 3;%
Mu2 = 0;%

sigma=1.5;

Sample_set1 =   normrnd(Mu1,sigma,num_s,1);
Sample_set2 =   normrnd(Mu2,sigma,num_s,1);

Data = [Sample_set1 ; Sample_set2];
% 
% 
% % Disegno le funzioni discriminanti per la due classi di campioni Gaussiani
% 
W1  = (1/sigma^2).*Mu1;
w10 = -(1/(2*sigma^2))*(Mu1'*Mu1) +log(Pw1);
G1 = sum(repmat(W1,1,num_s*2).*Data',1) + ones(1,num_s*2)*w10;


W2  = (1/sigma^2).*Mu2;
w20 = -(1/(2*sigma^2))*(Mu2'*Mu2) +log(Pw2);
G2 = sum(repmat(W2,1,num_s*2).*Data',1) + ones(1,num_s*2)*w20;
% 
% % Confine di decisione
W  = Mu1-Mu2;
X0 = 0.5*(Mu1+Mu2)-((sigma^2)./((Mu1-Mu2)'*(Mu1-Mu2))).*log(Pw1/Pw2).*(Mu1-Mu2);
% 
% 
h_CBayesG1D = figure; hold on;
[Ord,index_ord] = sort(Data,'ascend');
h_S1 = scatter(Sample_set1,zeros(num_s,1),10,'b');
h_S2 = scatter(Sample_set2,zeros(num_s,1),10,'r');
h_G1 = plot(Ord,G1(index_ord),'b');
h_G2 = plot(Ord,G2(index_ord),'r');
set(gcf,'name','Classificatore Bayesiano 2 classi 1D')
h_BayesG1D=line([X0;X0],[min([G1';G2']),max([G1';G2'])],'color',[0,0,0]);
%legend([h_G1;h_G2;h_BayesG1D],{'g_1(x)';'g_2(x)';'x_0'});
legend([h_S1(1);h_S2(1);h_G1;h_G2],{strcat('N1: \mu1=',num2str(Mu1),' \sigma1=',num2str(sigma));...
    strcat('N2: \mu2=',num2str(Mu2),' \sigma2=',num2str(sigma));...
    'g_1(x)';'g_2(x)'});

fprintf('FINE! \n')


